/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zkplus.databind.BindingListModel;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Doublebox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Colonia;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.FormaPago;
import com.rjconsultores.ventaboletos.entidad.FormaPagoDet;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.Nodo;
import com.rjconsultores.ventaboletos.entidad.ParamRecoleccion;
import com.rjconsultores.ventaboletos.entidad.PtoVtaUsuarioBancario;
import com.rjconsultores.ventaboletos.entidad.PtovtaEmpresa;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.entidad.UsuarioBancario;
import com.rjconsultores.ventaboletos.service.CiudadService;
import com.rjconsultores.ventaboletos.service.ColoniaService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.FormaPagoService;
import com.rjconsultores.ventaboletos.service.MonedaService;
import com.rjconsultores.ventaboletos.service.NodoService;
import com.rjconsultores.ventaboletos.service.PtoVtaUsuarioBancarioService;
import com.rjconsultores.ventaboletos.service.PtovtaEmpresaService;
import com.rjconsultores.ventaboletos.service.PuntoVentaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.service.UsuarioBancarioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;
import com.rjconsultores.ventaboletos.web.utilerias.render.FormaPagoDetRender;
import com.rjconsultores.ventaboletos.web.utilerias.render.ParamRecoleccionRender;
import com.rjconsultores.ventaboletos.web.utilerias.render.PtovtaEmpresaRender;
import com.rjconsultores.ventaboletos.web.utilerias.render.PtovtaUsuarioBancarioRender;

/**
 * 
 * @author Rafius
 */
@Controller("editarPuntoVentaController")
@Scope("prototype")
public class EditarPuntoVentaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private PuntoVentaService puntoVentaService;
	@Autowired
	private EmpresaService empresaService;
	@Autowired
	private TipoPuntoVentaService tipoPuntoVentaService;
	@Autowired
	private MonedaService monedaService;
	@Autowired
	private NodoService nodoService;
	@Autowired
	private FormaPagoService formaPagoService;
	@Autowired
	private CiudadService ciudadService;
	@Autowired
	private ColoniaService coloniaService;
	@Autowired
	private PtovtaEmpresaService ptovtaEmpresaService;
	@Autowired
	private PtoVtaUsuarioBancarioService ptoVtaUsuarioBancarioService;
	@Autowired
	private UsuarioBancarioService usuarioBancarioService;
	private PuntoVenta puntoVenta;
	private Textbox txtCP;
	private MyListbox puntoVentaList;
	private MyListbox paramRecoleccionList;
	private MyListbox formaPagoList;
	private MyListbox ptovtaEmpresaList;
	private MyListbox ptovtaUsuarioBancarioList;
	private static Logger log = Logger.getLogger(EditarPuntoVentaController.class);
	private List<Empresa> lsEmpresas;
	private List<TipoPuntoVenta> lsTipoPuntoVenta;
	private List<Moneda> lsMoneda;
	private List<Colonia> lsColonia;
	private List<Ciudad> lsCiudad;
	private List<Nodo> lsNodos;
	private List<FormaPago> lsFormaPago;
	private List<FormaPagoDet> lsFormaPagoDet;
	private List<ParamRecoleccion> lsParamRecoleccion;
	private List<UsuarioBancario> lsUsuarioBancario;
	private List<PtovtaEmpresa> lsPtovtaEmpresa;
	private List<PtoVtaUsuarioBancario> lsPtovtaUsuarioBancario;
	private MyTextbox txtNome;
	private Radio radDatosTarjetaSi;
	private Radio radDatosTarjetaNo;
	private Radio radAprobacionAutorizado;
	private Radio radAprobacionLatente;
	private Combobox cmbFormaPago;
	private Combobox cmbEmpresa;
	private Combobox cmbEmpresaPtoVta;
	private Combobox cmbEmpresaPtoVtaUsuarioBancario;
	private Combobox cmbParada;
	private Combobox cmbTipoPontoVenta;
	private Combobox cmbMoneda;
	private Combobox cmbNodo;
	private Button btnSalvarFormaPago;
	private Doublebox txtCargosExtras;
	private Button btnApagar;
	private Combobox cmbCiudad;
	private Combobox cmbColonia;
	private Combobox cmbConexion;
	private Combobox cmbUsuarioBancario;
	private Combobox cmbUsuarioBancarioPtoVtaUsuarioBancario;
	private MyTextboxDecimal importeInicial;
	private MyTextboxDecimal importeAdicional;

	public Button getBtnApagar() {
		return btnApagar;
	}

	public void setBtnApagar(Button btnApagar) {
		this.btnApagar = btnApagar;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		lsEmpresas = empresaService.obtenerIndTipo1();
		lsMoneda = monedaService.obtenerTodos();
		lsCiudad = ciudadService.obtenerTodos();
		lsColonia = new ArrayList<Colonia>();
		lsNodos = nodoService.obtenerTodos();
		lsFormaPago = formaPagoService.obtenerTodos();
		lsTipoPuntoVenta = tipoPuntoVentaService.obtenerTodos();
		lsUsuarioBancario = usuarioBancarioService.obtenerTodos();

		super.doAfterCompose(comp);
		try {
			txtCP.setDisabled(true);
			puntoVenta = (PuntoVenta) Executions.getCurrent().getArg().get("puntoVenta");
			if (puntoVenta.getPuntoventaId() != null) {
				puntoVenta = puntoVentaService.obtenerID(puntoVenta.getPuntoventaId());
				if (puntoVenta.getColonia() != null) {
					cmbCiudad.setText(puntoVenta.getColonia().getCiudad().getNombciudad());
					cmbColonia.setText(puntoVenta.getColonia().getDesccolonia());
				}
			}

			puntoVentaList = (MyListbox) Executions.getCurrent().getArg().get("puntoVentaList");

			if (puntoVenta.getPuntoventaId() != null) {
				if (puntoVenta.getStatusaprobacion() != null) {
					if (puntoVenta.getStatusaprobacion().equals("A")) {
						radAprobacionAutorizado.setChecked(true);
					} else if (puntoVenta.getStatusaprobacion().equals("L")) {
						radAprobacionLatente.setChecked(true);
					}
				}
			}

			formaPagoList.setItemRenderer(new FormaPagoDetRender());
			if (puntoVenta.getLsFormaPagoDet() == null) {
				puntoVenta.setLsFormaPagoDet(new ArrayList<FormaPagoDet>());
			}
			lsFormaPagoDet = puntoVenta.getLsFormaPagoDet();
			formaPagoList.setData(lsFormaPagoDet);

			paramRecoleccionList.setItemRenderer(new ParamRecoleccionRender());
			if (puntoVenta.getLsParamRecoleccion() == null) {
				puntoVenta.setLsParamRecoleccion(new ArrayList<ParamRecoleccion>());
			}

			lsParamRecoleccion = puntoVenta.getLsParamRecoleccion();
			paramRecoleccionList.setData(lsParamRecoleccion);

			ptovtaEmpresaList.setItemRenderer(new PtovtaEmpresaRender());
			if (puntoVenta.getLsPtovtaEmpresa() == null) {
				puntoVenta.setLsPtovtaEmpresa(new ArrayList<PtovtaEmpresa>());
			}

			lsPtovtaEmpresa = puntoVenta.getLsPtovtaEmpresa();
			ptovtaEmpresaList.setData(lsPtovtaEmpresa);

			ptovtaUsuarioBancarioList.setItemRenderer(new PtovtaUsuarioBancarioRender());
			if (puntoVenta.getLsPtovtaUsuarioBancario() == null) {
				puntoVenta.setLsPtovtaUsuarioBancario(new ArrayList<PtoVtaUsuarioBancario>());
			}

			lsPtovtaUsuarioBancario = puntoVenta.getLsPtovtaUsuarioBancario();
			ptovtaUsuarioBancarioList.setData(lsPtovtaUsuarioBancario);

			if (puntoVenta.getPuntoventaId() == null) {
				btnApagar.setVisible(Boolean.FALSE);
			} else {
				if (puntoVenta.getParada() != null) {
					cmbParada.setText(puntoVenta.getParada().getDescparada());
				}
			}
		} catch (Exception e) {
			log.error("Punto de Venta: " + e);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarEmpresaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
		txtNome.focus();
	}

	public void onChange$cmbCiudad(Event ev) {
		if (cmbCiudad.getSelectedItem() == null) {
			return;
		} else {
			cmbColonia.setSelectedItem(null);
			Ciudad c = (Ciudad) cmbCiudad.getSelectedItem().getValue();
			List<Colonia> lsCol = coloniaService.buscarPorCiudad(c);
			BindingListModel dictModel = new BindingListModelList(lsCol, false);
			cmbColonia.setModel(dictModel);
		}
	}

	public void onChange$cmbColonia(Event ev) {
		if (cmbColonia.getSelectedItem() == null) {
			return;
		} else {
			Colonia col = (Colonia) cmbColonia.getSelectedItem().getValue();
			txtCP.setValue(col.getCodpostal());
		}
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		txtNome.getValue();
		cmbEmpresa.getValue();
		cmbParada.getValue();
		cmbTipoPontoVenta.getValue();
		cmbMoneda.getValue();
		cmbNodo.getValue();
		cmbColonia.setConstraint("no empty");
		cmbColonia.getValue();
		cmbCiudad.getValue();
		try {
			if (puntoVenta.getEmpresa() == null) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.empresa"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else if (puntoVenta.getTipoPuntoVenta() == null) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.punto"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else if (puntoVenta.getMoneda() == null) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.moneda"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else if (puntoVenta.getNodo() == null) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.nodo"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else if (lsFormaPagoDet.isEmpty()) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.formaDePago"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else {

				if (cmbConexion.getValue().equals("")) {
					puntoVenta.setConexionBancaria(null);
					puntoVenta.setUsuarioBancario(null);
				}

				if (cmbUsuarioBancario.getValue() == null) {
					puntoVenta.setUsuarioBancario(null);
				}

				List<PuntoVenta> lsPv = puntoVentaService.buscar(puntoVenta);

				boolean podeSalvar = false;

				if (lsPv.isEmpty()) {
					podeSalvar = true;
				}
				for (PuntoVenta pv : lsPv) {
					if (pv.getPuntoventaId().equals(puntoVenta.getPuntoventaId())) {
						podeSalvar = true;
					}
				}

				if (podeSalvar) {
					if (cmbColonia.getSelectedItem() != null) {
						puntoVenta.setColonia((Colonia) cmbColonia.getSelectedItem().getValue());
					}
					puntoVenta.setActivo(Boolean.TRUE);
					puntoVenta.setFecmodif(Calendar.getInstance().getTime());
					puntoVenta.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
					puntoVenta.setLsFormaPagoDet(lsFormaPagoDet);
					puntoVenta.setLsParamRecoleccion(lsParamRecoleccion);
					puntoVenta.setLsPtovtaEmpresa(lsPtovtaEmpresa);
					puntoVenta.setLsPtovtaUsuarioBancario(lsPtovtaUsuarioBancario);

					List<PtovtaEmpresa> lsPto = new ArrayList<PtovtaEmpresa>();
					for (PtovtaEmpresa pto : lsPtovtaEmpresa) {
						if (!pto.getActivo()) {
							ptovtaEmpresaService.borrarFisico(pto);
						} else {
							pto.setPuntoVenta(puntoVenta);
							lsPto.add(pto);
						}
					}
					puntoVenta.setLsPtovtaEmpresa(lsPto);

					List<PtoVtaUsuarioBancario> lsPto2 = new ArrayList<PtoVtaUsuarioBancario>();
					for (PtoVtaUsuarioBancario pto2 : lsPtovtaUsuarioBancario) {
						if (!pto2.getActivo()) {
							ptoVtaUsuarioBancarioService.borrarFisico(pto2);
						} else {
							pto2.setPuntoVenta(puntoVenta);
							lsPto2.add(pto2);
						}
					}
					puntoVenta.setLsPtovtaUsuarioBancario(lsPto2);

					if (radAprobacionAutorizado.isChecked()) {
						puntoVenta.setStatusaprobacion("A");
					} else if (radAprobacionLatente.isChecked()) {
						puntoVenta.setStatusaprobacion("L");
					}

					if (puntoVenta.getPuntoventaId() == null) {
						puntoVentaService.suscribir(puntoVenta);
						puntoVentaList.addItem(puntoVenta);
					} else {
						puntoVentaService.actualizacion(puntoVenta);
						puntoVentaList.updateItem(puntoVenta);
					}

					Messagebox.show(
							Labels.getLabel("editarPuntoVentaController.MSG.suscribirOK"),
							Labels.getLabel("editarPuntoVentaController.window.title"),
							Messagebox.OK, Messagebox.INFORMATION);

					closeWindow();
				} else {
					Messagebox.show(
							Labels.getLabel("MSG.Registro.Existe"),
							Labels.getLabel("editarPuntoVentaController.window.title"),
							Messagebox.OK, Messagebox.EXCLAMATION);
				}
			}
		} catch (Exception ex) {
			log.error("editarPuntoVentaController: " + ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagar(Event ev) {
		try {
			int resp = Messagebox.show(
					Labels.getLabel("editarPuntoVentaController.MSG.borrarPergunta"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {

				puntoVentaService.borrar(puntoVenta);

				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.borrarOK"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				puntoVentaList.removeItem(puntoVenta);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public void onClick$btnSalvarFormaPago(Event ev) throws InterruptedException {
		cmbFormaPago.getValue();
		txtCargosExtras.getValue();
		try {
			FormaPago formaPago = new FormaPago();
			try {
				formaPago = (FormaPago) cmbFormaPago.getSelectedItem().getValue();
				Boolean achou = Boolean.FALSE;
				if (formaPago != null) {
					for (FormaPagoDet fpd : lsFormaPagoDet) {
						if (fpd.getFormaPago().getFormapagoId().equals(formaPago.getFormapagoId())) {
							achou = Boolean.TRUE;
						}
					}
					if (!achou) {
						FormaPagoDet fpd = new FormaPagoDet();
						fpd.setCargosextras(new BigDecimal(txtCargosExtras.getValue()));
						fpd.setFormaPago(formaPago);
						fpd.setPuntoVenta(puntoVenta);

						fpd.setActivo(Boolean.TRUE);
						fpd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
						fpd.setFecmodif(Calendar.getInstance().getTime());

						lsFormaPagoDet.add(fpd);
						formaPagoList.setData(lsFormaPagoDet);
					} else {
						Messagebox.show(
								Labels.getLabel("editarPuntoVentaController.MSG.Achou.FormaPago"),
								Labels.getLabel("editarPuntoVentaController.window.title"),
								Messagebox.OK, Messagebox.EXCLAMATION);
					}
				}
			} catch (Exception e) {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.formaDePago"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}
		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagarFormaPago(Event ev) {
		try {
			FormaPagoDet fpd = (FormaPagoDet) formaPagoList.getSelected();
			if (fpd != null) {
				fpd.setActivo(Boolean.FALSE);
				fpd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				fpd.setFecmodif(Calendar.getInstance().getTime());

				formaPagoList.removeItem(fpd);
				lsFormaPagoDet.remove(fpd);
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public void onClick$btnSalvarParamRecoleccion(Event ev) throws InterruptedException {
		importeInicial.getValue();
		importeAdicional.getValue();
		try {
			ParamRecoleccion paramRecoleccion = new ParamRecoleccion();
			paramRecoleccion.setImporteinicial(importeInicial.getValueDecimal());
			paramRecoleccion.setImporteadicional(importeAdicional.getValueDecimal());

			Boolean achou = Boolean.FALSE;

			for (ParamRecoleccion fpd : lsParamRecoleccion) {
				if (fpd.getImporteinicial().equals(paramRecoleccion.getImporteinicial())) {
					achou = Boolean.TRUE;
				}
			}
			if (!achou) {

				paramRecoleccion.setPuntoVenta(puntoVenta);
				paramRecoleccion.setActivo(Boolean.TRUE);
				paramRecoleccion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				paramRecoleccion.setFecmodif(Calendar.getInstance().getTime());

				lsParamRecoleccion.add(paramRecoleccion);
				paramRecoleccionList.setData(lsParamRecoleccion);
			} else {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.Achou.ParamRecoleccion"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}

		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagarParamRecoleccion(Event ev) {
		try {
			ParamRecoleccion fpd = (ParamRecoleccion) paramRecoleccionList.getSelected();
			if (fpd != null) {
				fpd.setActivo(Boolean.FALSE);
				fpd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				fpd.setFecmodif(Calendar.getInstance().getTime());

				paramRecoleccionList.removeItem(fpd);
				lsParamRecoleccion.remove(fpd);
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public void onClick$btnSalvarPtovtaEmpresa(Event ev) throws InterruptedException {
		cmbEmpresaPtoVta.getValue();
		try {
			PtovtaEmpresa ptovtaEmpresa = new PtovtaEmpresa();

			Boolean achou = Boolean.FALSE;

			ptovtaEmpresa.setEmpresa((Empresa) cmbEmpresaPtoVta.getSelectedItem().getValue());

			for (PtovtaEmpresa fpd : lsPtovtaEmpresa) {
				if (fpd.getEmpresa().equals(ptovtaEmpresa.getEmpresa())
						&& fpd.getActivo()) {
					achou = Boolean.TRUE;
				}
			}
			if (!achou) {

				ptovtaEmpresa.setPuntoVenta(puntoVenta);
				ptovtaEmpresa.setActivo(Boolean.TRUE);
				ptovtaEmpresa.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				ptovtaEmpresa.setFecmodif(Calendar.getInstance().getTime());

				lsPtovtaEmpresa.add(ptovtaEmpresa);

				List<PtovtaEmpresa> lsP = new ArrayList<PtovtaEmpresa>();
				for (PtovtaEmpresa p : lsPtovtaEmpresa) {
					if (p.getActivo()) {
						lsP.add(p);
					}
				}
				ptovtaEmpresaList.setData(lsP);
				// ptovtaEmpresaList.addItem(ptovtaEmpresa);
			} else {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.Achou.PtovtaEmpresa"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}

		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagarPtovtaEmpresa(Event ev) {
		try {
			PtovtaEmpresa fpd = (PtovtaEmpresa) ptovtaEmpresaList.getSelected();
			if (fpd != null) {
				lsPtovtaEmpresa.remove(fpd);
				ptovtaEmpresaList.removeItem(fpd);
				if (fpd.getPtovtaempresaId() != null) {
					fpd.setActivo(Boolean.FALSE);
					fpd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
					fpd.setFecmodif(Calendar.getInstance().getTime());
					fpd.setPuntoVenta(puntoVenta);

					lsPtovtaEmpresa.add(fpd);
				}
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public void onChange$cmbConexion(Event ev) {
		habilitarCombo();
	}

	private void habilitarCombo() {
		Comboitem cbi = cmbConexion.getSelectedItem();
		if (cbi != null) {
			String valor = (String) cbi.getValue();

			if (valor.equals("S")) {
				cmbUsuarioBancario.setDisabled(Boolean.FALSE);
			}
		}
	}

	public void onClick$btnSalvarPtovtaUsuarioBancario(Event ev) throws InterruptedException {
		cmbEmpresaPtoVtaUsuarioBancario.getValue();
		cmbUsuarioBancarioPtoVtaUsuarioBancario.getValue();

		try {
			PtoVtaUsuarioBancario usuarioBancario = new PtoVtaUsuarioBancario();
			usuarioBancario.setEmpresa((Empresa) cmbEmpresaPtoVtaUsuarioBancario.getSelectedItem().getValue());
			usuarioBancario.setUsuarioBancario((UsuarioBancario) cmbUsuarioBancarioPtoVtaUsuarioBancario.getSelectedItem().getValue());

			Boolean achou = Boolean.FALSE;

			for (PtoVtaUsuarioBancario fpd : lsPtovtaUsuarioBancario) {
				if (fpd.getEmpresa().equals(usuarioBancario.getEmpresa())) {
					achou = Boolean.TRUE;
				}
			}
			if (!achou) {

				usuarioBancario.setPuntoVenta(puntoVenta);
				usuarioBancario.setActivo(Boolean.TRUE);
				usuarioBancario.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				usuarioBancario.setFecmodif(Calendar.getInstance().getTime());

				lsPtovtaUsuarioBancario.add(usuarioBancario);

				List<PtoVtaUsuarioBancario> lsP = new ArrayList<PtoVtaUsuarioBancario>();
				for (PtoVtaUsuarioBancario p : lsPtovtaUsuarioBancario) {
					if (p.getActivo()) {
						lsP.add(p);
					}
				}
				ptovtaUsuarioBancarioList.setData(lsP);
				// ptovtaEmpresaList.addItem(ptovtaEmpresa);

			} else {
				Messagebox.show(
						Labels.getLabel("editarPuntoVentaController.MSG.Achou.PtovtaUsuario"),
						Labels.getLabel("editarPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			}

		} catch (Exception ex) {
			log.error(ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarPuntoVentaController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagarPtovtaUsuarioBancario(Event ev) {
		try {
			PtoVtaUsuarioBancario fpd = (PtoVtaUsuarioBancario) ptovtaUsuarioBancarioList.getSelected();
			if (fpd != null) {
				ptovtaUsuarioBancarioList.removeItem(fpd);
				lsPtovtaUsuarioBancario.remove(fpd);
				if (fpd.getPtovtaUsuarioBancarioID() != null) {
					fpd.setActivo(Boolean.FALSE);
					fpd.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
					fpd.setFecmodif(Calendar.getInstance().getTime());

					lsPtovtaUsuarioBancario.add(fpd);
				}
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public PuntoVenta getPuntoVenta() {
		return puntoVenta;
	}

	public void setPuntoVenta(PuntoVenta puntoVenta) {
		this.puntoVenta = puntoVenta;
	}

	public MyListbox getPuntoVentaList() {
		return puntoVentaList;
	}

	public void setPuntoVentaList(MyListbox puntoVentaList) {
		this.puntoVentaList = puntoVentaList;
	}

	public PuntoVentaService getPuntoVentaService() {
		return puntoVentaService;
	}

	public void setPuntoVentaService(PuntoVentaService puntoVentaService) {
		this.puntoVentaService = puntoVentaService;
	}

	public EmpresaService getEmpresaService() {
		return empresaService;
	}

	public void setEmpresaService(EmpresaService empresaService) {
		this.empresaService = empresaService;
	}

	public TipoPuntoVentaService getTipoPuntoVentaService() {
		return tipoPuntoVentaService;
	}

	public void setTipoPuntoVentaService(TipoPuntoVentaService tipoPuntoVentaService) {
		this.tipoPuntoVentaService = tipoPuntoVentaService;
	}

	public List<Empresa> getLsEmpresas() {
		return lsEmpresas;
	}

	public void setLsEmpresas(List<Empresa> lsEmpresas) {
		this.lsEmpresas = lsEmpresas;
	}

	public List<TipoPuntoVenta> getLsTipoPuntoVenta() {
		return lsTipoPuntoVenta;
	}

	public void setLsTipoPuntoVenta(List<TipoPuntoVenta> lsTipoPuntoVenta) {
		this.lsTipoPuntoVenta = lsTipoPuntoVenta;
	}

	public MonedaService getMonedaService() {
		return monedaService;
	}

	public void setMonedaService(MonedaService monedaService) {
		this.monedaService = monedaService;
	}

	public List<Moneda> getLsMoneda() {
		return lsMoneda;
	}

	public void setLsMoneda(List<Moneda> lsMoneda) {
		this.lsMoneda = lsMoneda;
	}

	public Radio getRadAprobacionAutorizado() {
		return radAprobacionAutorizado;
	}

	public void setRadAprobacionAutorizado(Radio radAprobacionAutorizado) {
		this.radAprobacionAutorizado = radAprobacionAutorizado;
	}

	public Radio getRadAprobacionLatente() {
		return radAprobacionLatente;
	}

	public void setRadAprobacionLatente(Radio radAprobacionLatente) {
		this.radAprobacionLatente = radAprobacionLatente;
	}

	public Radio getRadDatosTarjetaNo() {
		return radDatosTarjetaNo;
	}

	public void setRadDatosTarjetaNo(Radio radDatosTarjetaNo) {
		this.radDatosTarjetaNo = radDatosTarjetaNo;
	}

	public Radio getRadDatosTarjetaSi() {
		return radDatosTarjetaSi;
	}

	public void setRadDatosTarjetaSi(Radio radDatosTarjetaSi) {
		this.radDatosTarjetaSi = radDatosTarjetaSi;
	}

	public MyTextbox getTxtNome() {
		return txtNome;
	}

	public void setTxtNome(MyTextbox txtNome) {
		this.txtNome = txtNome;
	}

	public MyListbox getFormaPagoList() {
		return formaPagoList;
	}

	public void setFormaPagoList(MyListbox formaPagoList) {
		this.formaPagoList = formaPagoList;
	}

	public List<FormaPago> getLsFormaPago() {
		return lsFormaPago;
	}

	public void setLsFormaPago(List<FormaPago> lsFormaPago) {
		this.lsFormaPago = lsFormaPago;
	}

	public Combobox getCmbFormaPago() {
		return cmbFormaPago;
	}

	public void setCmbFormaPago(Combobox cmbFormaPago) {
		this.cmbFormaPago = cmbFormaPago;
	}

	public Doublebox getTxtCargosExtras() {
		return txtCargosExtras;
	}

	public void setTxtCargosExtras(Doublebox txtCargosExtras) {
		this.txtCargosExtras = txtCargosExtras;
	}

	public List<Nodo> getLsNodos() {
		return lsNodos;
	}

	public void setLsNodos(List<Nodo> lsNodos) {
		this.lsNodos = lsNodos;
	}

	public Button getBtnSalvarFormaPago() {
		return btnSalvarFormaPago;
	}

	public void setBtnSalvarFormaPago(Button btnSalvarFormaPago) {
		this.btnSalvarFormaPago = btnSalvarFormaPago;
	}

	public FormaPagoService getFormaPagoService() {
		return formaPagoService;
	}

	public void setFormaPagoService(FormaPagoService formaPagoService) {
		this.formaPagoService = formaPagoService;
	}

	public List<FormaPagoDet> getLsFormaPagoDet() {
		return lsFormaPagoDet;
	}

	public void setLsFormaPagoDet(List<FormaPagoDet> lsFormaPagoDet) {
		this.lsFormaPagoDet = lsFormaPagoDet;
	}

	public Combobox getCmbCiudad() {
		return cmbCiudad;
	}

	public void setCmbCiudad(Combobox cmbCiudad) {
		this.cmbCiudad = cmbCiudad;
	}

	public Combobox getCmbEmpresa() {
		return cmbEmpresa;
	}

	public void setCmbEmpresa(Combobox cmbEmpresa) {
		this.cmbEmpresa = cmbEmpresa;
	}

	public Combobox getCmbParada() {
		return cmbParada;
	}

	public void setCmbParada(Combobox cmbParada) {
		this.cmbParada = cmbParada;
	}

	public Combobox getCmbMoneda() {
		return cmbMoneda;
	}

	public void setCmbMoneda(Combobox cmbMoneda) {
		this.cmbMoneda = cmbMoneda;
	}

	public Combobox getCmbNodo() {
		return cmbNodo;
	}

	public void setCmbNodo(Combobox cmbNodo) {
		this.cmbNodo = cmbNodo;
	}

	public Combobox getCmbTipoPontoVenta() {
		return cmbTipoPontoVenta;
	}

	public void setCmbTipoPontoVenta(Combobox cmbTipoPontoVenta) {
		this.cmbTipoPontoVenta = cmbTipoPontoVenta;
	}

	/**
	 * @return the lsColonia
	 */
	public List<Colonia> getLsColonia() {
		return lsColonia;
	}

	/**
	 * @param lsColonia
	 *            the lsColonia to set
	 */
	public void setLsColonia(List<Colonia> lsColonia) {
		this.lsColonia = lsColonia;
	}

	/**
	 * @return the lsCiudad
	 */
	public List<Ciudad> getLsCiudad() {
		return lsCiudad;
	}

	/**
	 * @param lsCiudad
	 *            the lsCiudad to set
	 */
	public void setLsCiudad(List<Ciudad> lsCiudad) {
		this.lsCiudad = lsCiudad;
	}

	/**
	 * @return the cmbColonia
	 */
	public Combobox getCmbColonia() {
		return cmbColonia;
	}

	/**
	 * @param cmbColonia
	 *            the cmbColonia to set
	 */
	public void setCmbColonia(Combobox cmbColonia) {
		this.cmbColonia = cmbColonia;
	}

	/**
	 * @return the txtCP
	 */
	public Textbox getTxtCP() {
		return txtCP;
	}

	/**
	 * @param txtCP
	 *            the txtCP to set
	 */
	public void setTxtCP(Textbox txtCP) {
		this.txtCP = txtCP;
	}

	public List<UsuarioBancario> getLsUsuarioBancario() {
		return lsUsuarioBancario;
	}

	public void setLsUsuarioBancario(List<UsuarioBancario> lsUsuarioBancario) {
		this.lsUsuarioBancario = lsUsuarioBancario;
	}

	public List<ParamRecoleccion> getLsParamRecoleccion() {
		return lsParamRecoleccion;
	}

	public void setLsParamRecoleccion(List<ParamRecoleccion> lsParamRecoleccion) {
		this.lsParamRecoleccion = lsParamRecoleccion;
	}

	public MyListbox getParamRecoleccionList() {
		return paramRecoleccionList;
	}

	public void setParamRecoleccionList(MyListbox paramRecoleccionList) {
		this.paramRecoleccionList = paramRecoleccionList;
	}

	public List<PtovtaEmpresa> getLsPtovtaEmpresa() {
		return lsPtovtaEmpresa;
	}

	public void setLsPtovtaEmpresa(List<PtovtaEmpresa> lsPtovtaEmpresa) {
		this.lsPtovtaEmpresa = lsPtovtaEmpresa;
	}

	public MyListbox getPtovtaEmpresaList() {
		return ptovtaEmpresaList;
	}

	public void setPtovtaEmpresaList(MyListbox ptovtaEmpresaList) {
		this.ptovtaEmpresaList = ptovtaEmpresaList;
	}

	public List<PtoVtaUsuarioBancario> getLsPtovtaUsuarioBancario() {
		return lsPtovtaUsuarioBancario;
	}

	public void setLsPtovtaUsuarioBancario(List<PtoVtaUsuarioBancario> lsPtovtaUsuarioBancario) {
		this.lsPtovtaUsuarioBancario = lsPtovtaUsuarioBancario;
	}

	public MyListbox getPtovtaUsuarioBancarioList() {
		return ptovtaUsuarioBancarioList;
	}

	public void setPtovtaUsuarioBancarioList(MyListbox ptovtaUsuarioBancarioList) {
		this.ptovtaUsuarioBancarioList = ptovtaUsuarioBancarioList;
	}
}
