/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;

import com.rjconsultores.ventaboletos.entidad.VigenciaTarifa;
import com.rjconsultores.ventaboletos.service.TarifaOficialService;
import com.rjconsultores.ventaboletos.service.VigenciaTarifaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;

/**
 * 
 * @author Gleimar
 */
@Controller("copiarTarifaOficialController")
@Scope("prototype")
public class CopiarTarifaOficialController extends MyGenericForwardComposer {

	private static Logger log = Logger.getLogger(CopiarTarifaOficialController.class);

	@Autowired
	private VigenciaTarifaService vigenciaTarifaService;
	@Autowired
	private TarifaOficialService tarifaOficialService;
	private List<VigenciaTarifa> lsVigenciaTarifa;
	private Combobox cmbVigencia;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		lsVigenciaTarifa = vigenciaTarifaService.obtenerTodos();
		super.doAfterCompose(comp);
	}

	public void onClick$btnGenerarVigencia(Event ev) throws InterruptedException {

		cmbVigencia.getValue();

		tarifaOficialService.copiarParaTarifa((VigenciaTarifa) cmbVigencia.getSelectedItem().getValue());

		Messagebox.show(Labels.getLabel("copiarTarifaOficialController.MSG.copiaOK"),
				Labels.getLabel("indexController.mniGenerarTarifaOrgao.label"),
				Messagebox.OK, Messagebox.INFORMATION);
	}

	public List<VigenciaTarifa> getLsVigenciaTarifa() {
		return lsVigenciaTarifa;
	}
}
